﻿using System;
using System.Text;
using System.Threading;

using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using GHIElectronics.NETMF.FEZ;
using GHIElectronics.NETMF.Net;
using GHIElectronics.NETMF.Net.Sockets;
using GHIElectronics.NETMF.Net.NetworkInformation;
using Socket = GHIElectronics.NETMF.Net.Sockets.Socket;

namespace FEZ_Panda_II_Test_Connect_HTTP
{   // -----------------
    // Test HTTP sur PANDA2
    // -----------------
    public class Program
    {
        public static void Main()
        {
            const Int32 c_port = 80;

            // Config Ethernet de la carte Panda2 (IP fixe)
            byte[] ip = { 192, 168, 40, 2 };
            byte[] subnet = { 255, 255, 255, 0 };
            byte[] gateway = { 192, 168, 40, 254 };
            byte[] mac = { 0x00, 0x26, 0x1C, 0x7B, 0x29, 0xE8 };
            WIZnet_W5100.Enable(SPI.SPI_module.SPI1, (Cpu.Pin)FEZ_Pin.Digital.Di10, (Cpu.Pin)FEZ_Pin.Digital.Di7, true);
            //Dhcp.EnableDhcp(new byte[] {0x00, 0x7E, 0x60, 0x1C, 0x58, 0x71}, "ServeurWebPhil"); // DHCP
            NetworkInterface.EnableStaticIP(ip, subnet, gateway, mac);
            NetworkInterface.EnableStaticDns(new byte[] {192, 168, 40, 254});

            // Config et démarrage Http
            HttpListener listener = new HttpListener("http", c_port);
            listener.Start();

            while (true)
            {
                HttpListenerResponse response = null;
                HttpListenerContext context = null;

                try
                {
                    context = listener.GetContext();
                    response = context.Response;
                    // On ignore la requette GET 
                    // HttpListenerRequest request = context.Request;

                    // Envoie de la réponse
                    response.StatusCode = (int)HttpStatusCode.OK;
                    byte[] HTML = Encoding.UTF8.GetBytes(
                        "<html>" +
                        "<head>" +
                            "<title>1STI2D: TP1 R&eacute;seaux</title>" +
                            "<style type=\"text/css\">" +
                                "body{font-family:Arial, Helvetica, sans-serif}" +
                                "h2,p{text-align:center;}" +
                                "td{vertical-align: middle;}" +
                                "table {border:solid; border-width:2px; text-align:center;" +
                            "</style>" +
                        "</head>" +
                        "<body>" +
                            "<h2> TP1 R&eacute;seaux TCP/IP </h2>" +
                            "<table align=\"center\">" +
                                "<tr>" +
                                    "<td colspan=\"2\">Lyc&eacute;e Pierre Emile Martin</td>" +
                                "</tr>"+
                                "<tr>" +
                                    "<td>Classe:</td>" +
                                    " <td>1STI2D</td>" +
                                "</tr>" +
                                "<tr>" +
                                    "<td>Option:</td>" +
                                    "<td> Syst&egrave;me d'information et num&eacute;rique</td>" +
                                "</tr>" +
                                "<tr>" +
                                    "<td>Module:</td>" +
                                    "<td>Panda 2 </td>" +
                                "</tr>" +
                            "</table>" +
                            "<p> Test de la connexion : ok </p>" +
                        "</body>" +
                        "</html>");
                        
                    response.ContentType = "text/html";
                    response.OutputStream.Write(HTML, 0, HTML.Length);
                    response.Close();
                }

                catch
                {
                    if (context != null)
                    {
                        context.Close();
                    }
                }
            }
        }
    }
}
